#include<systemc.h>
#include "mixcolum.h"
	
SC_MODULE(testert)
{
	sc_in<bool> clk;

	sc_out<bool> reset;

	sc_out<bool> decrypt;
	sc_out<bool> start;
	sc_out<sc_biguint<128> > data_o;

	sc_in<bool> ready;
	sc_in<sc_biguint<128> > data_i;


	void test()
	{
		sc_biguint<128> data;
		data = 3737;	
		data <<= 32;
		data |=  23939;
		data <<= 32;
		data |= -3779;
		data <<= 32;
		data |= -2774;

		reset = true;
		wait();

		while(true)
		{

			data_o = data;
			decrypt = false;

			wait();
			start = true;
			wait();
			start = false;
			do
			{
				wait();
			}
			 while(ready.read() != true);

			data_o = data_i.read();
			decrypt=true;

			wait();
			
			start = true;
			
			wait();

			start = false;
			do
			{
				wait();
			}while(ready.read() != true);
			
			wait();
		}		
	}
	
	SC_CTOR(testert)
	{
		SC_THREAD(test);
		sensitive << clk.pos();

	}
};

int sc_main(int argc, char* argv[])
{
	sc_clock clk;
	sc_signal<bool> reset;
	sc_signal<bool> decrypt;
	sc_signal<bool> start;
	sc_signal<sc_biguint<128> > a;
	sc_signal<bool> ready;
	sc_signal<sc_biguint<128> > b;
	
	mixcolum mix("mix");
	mix.clk(clk);
	mix.reset(reset);
	mix.decrypt_i(decrypt);
	mix.start_i(start);
	mix.data_i(a);
	mix.ready_o(ready);
	mix.data_o(b);
	
	testert tester("tester");
	tester.clk(clk);
	tester.reset(reset);
	tester.decrypt(decrypt);
	tester.start(start);
	tester.data_i(b);
	tester.ready(ready);
	tester.data_o(a);

#if 0
	sc_trace_file* ptf = sc_create_vcd_trace_file("mixcolum_test");
	sc_trace<bool>(ptf,clk,"clk");
	sc_trace<bool>(ptf,reset,"reset");
	sc_trace<bool>(ptf,ready,"ready");
	sc_trace<bool>(ptf,decrypt,"decrypt");
	sc_trace<bool>(ptf,start,"start");
	sc_trace<sc_biguint<128> >(ptf,a,"a");
	sc_trace<sc_biguint<128> >(ptf,b,"b");
#endif
	
	sc_start(10000000);
	

	return 0;
}
