#include <systemc.h>

int counter1;
int counter2;

SC_MODULE(module)
{
	sc_in<bool> clk;
	void run1()
	{
		while(true)
		{
			assert(clk.posedge());
			bool b = clk.read();
			wait();
			assert(b == clk.read());
			counter1++;
		}
	}

	void run2()
	{
		assert(clk.read() == false);
		assert(clk.event() == false);
		while(true)
		{
			bool b = clk.read();
			wait();
			assert(b != clk.read());
			counter2++;
		}
	}

	SC_CTOR(module)
	{
		SC_CTHREAD(run1,clk.pos());
		SC_THREAD(run2);
		sensitive << clk;
	}
};

int sc_main(int argc, char* argv[])
{
	sc_clock clk;
	module mod("module");
	mod.clk(clk);
	sc_start(10, SC_NS);
	assert(counter1==9);
	assert(counter2==20);
	return 0;
}
